-- 
-- /run print(tonumber("0x"..(UnitGUID("target")or""):sub(6,10),16)or ERR_GENERIC_NO_TARGET)
-- http://www.wowwiki.com/Maps

NPCSilencerData = {}

--
-- Default Settings
--

NPCSilencerData.Enabled = nil
NPCSilencerData.MinimapHide = nil
NPCSilencerData.MinimapPosition = 180

--
-- Localization
--

NPCSILENCER_DEBUG = "Debug"
NPCSILENCER_DISABLED = "NPC-Silencer disabled!"
NPCSILENCER_ENABLED = "NPC-Silencer activated!"
NPCSILENCER_ERROR = "Error"
NPCSILENCER_ISNOWLOADED = "is now loaded!"
NPCSILENCER_TITLE = "NPC-Silencer"
--NPCSILENCER_TOGGLEINFO = "UPDATES IN npc_silencerFrameMinimapButton_InitButton FUNCTION"
NPCSILENCER_VERSION = "50200.231"

--
-- LibDataBroker Handling
--

local LibDataBroker = LibStub:GetLibrary("LibDataBroker-1.1")

local LibDataBrokerObj = LibDataBroker:NewDataObject("NPC-Silencer", {
  	type = "launcher", icon = "Interface\\AddOns\\npc-silencer\\icons\\npc-on", OnClick = function(self, button)
    	if button == "LeftButton" then
      	npc_silencerFrameMinimapButton_OnClick()
    	end
  end,
  OnTooltipShow = function(tooltip)
    npc_silencerFrameCreateTooltip(tooltip)
  end,
})

--
-- npc_silencerFrame Functions
--

function npc_silencerFrame_OnLoad(self)
	DEFAULT_CHAT_FRAME:AddMessage("|cffff2020NPC-Silencer |rVersion "..NPCSILENCER_VERSION.." loaded.", 1, 1, 1, 1, 10)
	DEFAULT_CHAT_FRAME:AddMessage("Please report non silenced npc's to wow-addons@o2online.de or as comment at http://www.wowinterface.com - Please tell us the city and npcname like 'Topper McNapp in Stormwind', so we can add them to the next version. Thanks for your help!", 1, 1, 1, 1, 10)

	self:RegisterEvent("ADDON_LOADED")
	self:RegisterEvent("PLAYER_ENTERING_WORLD")

	npc_silencerFrame_CheckButtonVisibility()
end

function npc_silencerFrame_OnEvent(self, event, name)
	if event == "ADDON_LOADED" and name == "npc-silencer" then
    		self:UnregisterEvent(event)

    		npc_silencerFrameMinimapButton_Reposition()
    		npc_silencerFrameMinimapButton_InitButton(1)
  	end
end

function npc_silencerFrame_CheckButtonVisibility()
  	if NPCSilencerData.MinimapHide then
    		npc_silencerFrameMinimapButton:Hide()
  	else
    		npc_silencerFrameMinimapButton:Show()
  	end
end

--function npc_silencerFrame_ToggleButton() -- NOT IN USE
--  if NPCSilencerData.MinimapHide then
--    NPCSilencerData.MinimapHide = nil
--  else
--    NPCSilencerData.MinimapHide = 1
--  end    
--  npc_silencerFrame_CheckButtonVisibility()
--end

--
-- MinimapButton Functions
--

function npc_silencerFrameMinimapButton_OnLoad(button)
	button:RegisterForClicks("LeftButtonUp", "RightButtonUp")
	button:RegisterForDrag("LeftButton", "RightButton")
end

function npc_silencerFrameMinimapButton_OnClick(button)
  	if NPCSilencerData.Enabled then
    		NPCSilencerData.Enabled = nil
  	else
    		NPCSilencerData.Enabled = 1
  	end

	npc_silencerFrameMinimapButton_InitButton()
  	npc_silencerFrameShowTooltip(button)
end

function npc_silencerFrameMinimapButton_OnEnter(button)
  	npc_silencerFrameShowTooltip(button)
end

function npc_silencerFrameMinimapButton_OnLeave(button)
  	GameTooltip:Hide()
end

function npc_silencerFrameMinimapButton_InitButton(quiet)
  	if NPCSilencerData.Enabled then
    		if not quiet then
      		DEFAULT_CHAT_FRAME:AddMessage(NPCSILENCER_ENABLED, 1, 1, 1, 1, 10)
    		end

	    	npc_silencerFrameMinimapButtonIcon:SetTexture("Interface\\Addons\\npc-silencer\\icons\\npc-on")
	    	LibDataBrokerObj.icon = "Interface\\Addons\\npc-silencer\\icons\\npc-on"
	    	NPCSILENCER_TOGGLEINFO = "<Enabled>"
  	else
    		if not quiet then
      		DEFAULT_CHAT_FRAME:AddMessage(NPCSILENCER_DISABLED, 1, 1, 1, 1, 10)
    		end

    		npc_silencerFrameMinimapButtonIcon:SetTexture("Interface\\Addons\\npc-silencer\\icons\\npc-off")
    		LibDataBrokerObj.icon = "Interface\\Addons\\npc-silencer\\icons\\npc-off"
    		NPCSILENCER_TOGGLEINFO = "<Disabled>"
  	end
end

local minimapShapes = {
	["ROUND"] = {true, true, true, true},
	["SQUARE"] = {false, false, false, false},
	["CORNER-TOPLEFT"] = {false, false, false, true},
	["CORNER-TOPRIGHT"] = {false, false, true, false},
	["CORNER-BOTTOMLEFT"] = {false, true, false, false},
	["CORNER-BOTTOMRIGHT"] = {true, false, false, false},
	["SIDE-LEFT"] = {false, true, false, true},
	["SIDE-RIGHT"] = {true, false, true, false},
	["SIDE-TOP"] = {false, false, true, true},
	["SIDE-BOTTOM"] = {true, true, false, false},
	["TRICORNER-TOPLEFT"] = {false, true, true, true},
	["TRICORNER-TOPRIGHT"] = {true, false, true, true},
	["TRICORNER-BOTTOMLEFT"] = {true, true, false, true},
	["TRICORNER-BOTTOMRIGHT"] = {true, true, true, false},
}

function npc_silencerFrameMinimapButton_Reposition()
  	local angle = math.rad(NPCSilencerData.MinimapPosition)
  	local x, y, q = math.cos(angle), math.sin(angle), 1
  	if x < 0 then q = q + 1 end
  	if y > 0 then q = q + 2 end
  	local minimapShape = GetMinimapShape and GetMinimapShape() or "ROUND"
  	local quadTable = minimapShapes[minimapShape]
  	if quadTable[q] then
    		x, y = x*80, y*80
  	else
    		local diagRadius = 103.13708498985 --math.sqrt(2*(80)^2)-10
    		x = math.max(-80, math.min(x*diagRadius, 80))
    		y = math.max(-80, math.min(y*diagRadius, 80))
  	end
  	
  	npc_silencerFrameMinimapButton:ClearAllPoints()
  	npc_silencerFrameMinimapButton:SetPoint("CENTER", Minimap, "CENTER", x, y)
end

function npc_silencerFrameMinimapButtonDraggingFrame_OnUpdate()
  	local mx, my = Minimap:GetCenter()
  	local px, py = GetCursorPosition()
  	local scale = Minimap:GetEffectiveScale()
  	px, py = px/scale, py/scale
  	NPCSilencerData.MinimapPosition = math.deg(math.atan2(py - my, px - mx)) % 360
  	npc_silencerFrameMinimapButton_Reposition()
end

function npc_silencerFrameMinimapButton_OnDragStart(button)
  	button:LockHighlight()
  	npc_silencerFrameMinimapButtonDraggingFrame:Show()
end

function npc_silencerFrameMinimapButton_OnDragStop(button)
  	button:UnlockHighlight()
  	npc_silencerFrameMinimapButtonDraggingFrame:Hide()
end

--
-- MinimapButton Tooltip Functions
--

function npc_silencerFrameCreateTooltip(tooltip)
  	tooltip:SetText("|cffffffffNPC-Silencer|r")
  	tooltip:AddLine(NPCSILENCER_TOGGLEINFO, nil, nil, nil, 1)
  	tooltip:Show()
end

function npc_silencerFrameShowTooltip(button)
  	GameTooltip_SetDefaultAnchor(GameTooltip, button)
  	npc_silencerFrameCreateTooltip(GameTooltip)
end

--
-- Database and Chat handling
--

do
  local events = {
    "CHAT_MSG_MONSTER_EMOTE",
    "CHAT_MSG_MONSTER_PARTY",
    "CHAT_MSG_MONSTER_SAY",
    "CHAT_MSG_MONSTER_WHISPER",
    "CHAT_MSG_MONSTER_YELL"
  }

  local database = {

-- Alteracgebirge
	["2318"] = 1, ["2421"] = 1, ["2705"] = 1, ["2253"] = 1, ["2254"] = 1, ["2287"] = 1,

-- Alteractal
	["11948"] = 1, ["11949"] = 1, ["13181"] = 1, ["11677"] = 1, ["14848"] = 1, ["11946"] = 1,

-- Azurmythoinsel
	["17268"] = 1, ["17071"] = 1, ["16551"] = 1, ["20227"] = 1, ["16522"] = 1, ["16502"] = 1, ["16501"] = 1, ["16521"] = 1, ["16483"] = 1, ["16551"] = 1, ["17222"] = 1, ["17228"] = 1, ["17214"] = 1, ["17215"] = 1,

-- Blutmythoinsel
	["17825"] = 1, ["17824"] = 1, ["17663"] = 1,

-- Black Tempel
	["22990"] = 1, ["23319"] = 1, ["22948"] = 1, ["23418"] = 1, ["23419"] = 1, ["23420"] = 1, ["22947"] = 1, ["23410"] = 1, ["23411"] = 1, ["22917"] = 1,

-- Brachland
	["37908"] = 1, ["38380"] = 1, ["37487"] = 1, ["6244"] = 1, ["6246"] = 1, ["6245"] = 1, ["3489"] = 1, ["3429"] = 1, ["3490"] = 1, ["3390"] = 1, ["3431"] = 1, ["3482"] = 1,

-- Smpfe des Elends / Swamp of Sorrows
	["66518"] = 1, 

-- Brann Bronzebart
	["28070"] = 1, ["29579"] = 1, ["30107"] = 1, ["30382"] = 1, ["30405"] = 1, ["31810"] = 1, ["34044"] = 1, ["39908"] = 1, ["49204"] = 1, ["49248"] = 1, ["49351"] = 1, ["49468"] = 1, ["49472"] = 1, ["49941"] = 1, ["51174"] = 1, 

-- Brennende Steppe / Burning Steppes
	["47811"] = 1, ["47779"] = 1, ["48246"] = 1, ["48099"] = 1, ["9176"] = 1, ["48037"] = 1, ["48159"] = 1, ["48133"] = 1, ["48119"] = 1, ["7029"] = 1, ["48201"] = 1, ["48345"] = 1, ["48100"] = 1, ["7025"] = 1, ["48292"] = 1, ["48307"] = 1, ["48312"] = 1, ["49314"] = 1, ["7035"] = 1, ["48314"] = 1, 

-- Boreanische Tundra 1 / Borean Tundra
	["27888"] = 1, ["25821"] = 1, ["25820"] = 1, ["25514"] = 1, ["25833"] = 1, ["25831"] = 1, ["25747"] = 1, ["26171"] = 1, ["25378"] = 1, ["25827"] = 1, ["25522"] = 1, ["25613"] = 1, ["25235"] = 1, ["25209"] = 1, ["25197"] = 1, ["25601"] = 1, ["26189"] = 1, ["26225"] = 1, ["26266"] = 1, ["26218"] = 1, ["25834"] = 1, ["25428"] = 1, ["25335"] = 1, ["25429"] = 1, ["25682"] = 1, ["25830"] = 1, ["25832"] = 1, ["25823"] = 1, ["26206"] = 1, ["26237"] = 1, ["34310"] = 1, ["25773"] = 1, ["25477"] = 1, ["26117"] = 1, ["25356"] = 1, ["25784"] = 1, ["25785"] = 1, ["27300"] = 1, ["27299"] = 1, ["25584"] = 1, ["25618"] = 1, ["25318"] = 1, ["25320"] = 1, ["25521"] = 1, ["26450"] = 1, ["25258"] = 1, ["25261"] = 1, ["25259"] = 1, ["25245"] = 1, ["25250"] = 1, ["25238"] = 1, ["25222"] = 1, ["25678"] = 1, ["26595"] = 1, ["28065"] = 1, ["28063"] = 1, 
				
-- Boreanische Tundra 2 / Borean Tundra
	["25301"] = 1, ["25285"] = 1, ["25453"] = 1, ["26538"] = 1, ["25260"] = 1, ["52242"] = 1, ["28375"] = 1, ["25208"] = 1, ["25201"] = 1, ["25768"] = 1, ["25814"] = 1, ["25793"] = 1, ["26817"] = 1, ["25714"] = 1, ["25783"] = 1, ["25753"] = 1, ["25589"] = 1, ["25322"] = 1, ["25321"] = 1, ["26073"] = 1, ["26185"] = 1, ["26170"] = 1, ["25251"] = 1, ["25801"] = 1, ["25836"] = 1, ["25835"] = 1, ["25806"] = 1, ["25979"] = 1, ["25220"] = 1, ["25317"] = 1, ["27364"] = 1, ["27010"] = 1, ["25467"] = 1, ["25828"] = 1, ["25248"] = 1, ["26076"] = 1, ["26203"] = 1, ["26794"] = 1, ["25802"] = 1, ["25220"] = 1, ["26403"] = 1, ["23953"] = 1, ["24200"] = 1, ["24201"] = 1, ["23954"] = 1,  

-- Darnassus
	["36479"] = 1, ["36481"] = 1, ["18917"] = 1, ["4730"] = 1,

-- Dmmerwald / Duskwood
	["45740"] = 1, ["325"] = 1, ["264"] = 1, ["468"] = 1, ["273"] = 1, ["270"] = 1, ["271"] = 1, ["272"] = 1, ["269"] = 1, ["263"] = 1, ["2112"] = 1, ["315"] = 1, ["43453"] = 1, ["212"] = 1, ["1251"] = 1, ["889"] = 1, ["43858"] = 1, ["43950"] = 1, ["43453"] = 1, ["3301"] = 1, ["3946"] = 1, 

-- Dalaran
	["28725"] = 1, ["28951"] = 1, ["30116"] = 1, ["36669"] = 1, ["30115"] = 1, ["28722"] = 1, ["16128"] = 1, ["30658"] = 1, ["30667"] = 1, ["32191"] = 1, ["32641"] = 1, ["29523"] = 1, ["33027"] = 1, ["28994"] = 1, ["31238"] = 1, ["32692"] = 1, ["32687"] = 1, ["28715"] = 1, ["24534"] = 1, ["24238"] = 1, ["24015"] = 1, ["24634"] = 1, ["28776"] = 1, ["29497"] = 1, ["28715"] = 1, ["29714"] = 1, ["28997"] = 1, ["28721"] = 1, ["28725"] = 1, ["28727"] = 1, ["28723"] = 1, ["28714"] = 1, ["28718"] = 1, ["28728"] = 1, ["32170"] = 1, ["32169"] = 1, ["28726"] = 1, ["29528"] = 1, ["28989"] = 1, ["29478"] = 1, ["29491"] = 1, 

-- Desolace
	["11625"] = 1, ["5644"] = 1,

-- Der heulende Fjord
	["24191"] = 1, ["24528"] = 1, ["23891"] = 1, ["24029"] = 1, ["23666"] = 1, ["24473"] = 1, ["23667"] = 1, ["23665"] = 1, ["24910"] = 1, ["27933"] = 1, ["24796"] = 1, ["24911"] = 1, ["24754"] = 1, ["24322"] = 1, ["24323"] = 1, ["24767"] = 1, ["24643"] = 1, ["24009"] = 1, ["24635"] = 1, ["24221"] = 1, ["24216"] = 1, ["23651"] = 1, ["24051"] = 1, ["23658"] = 1, ["24779"] = 1, ["24250"] = 1, ["24249"] = 1, ["24169"] = 1, ["23660"] = 1, ["24086"] = 1, ["24096"] = 1, ["24103"] = 1, ["24089"] = 1, ["24097"] = 1, ["23739"] = 1, ["24088"] = 1, ["24090"] = 1, ["24077"] = 1, ["23551"] = 1, ["24258"] = 1, ["24118"] = 1, ["24900"] = 1, ["24790"] = 1, ["24742"] = 1, ["24784"] = 1, ["24639"] = 1, ["24788"] = 1, ["24807"] = 1, ["24719"] = 1, ["24271"] = 1, ["23672"] = 1, ["24398"] = 1, ["24023"] = 1, ["24014"] = 1, ["23991"] = 1, ["23990"] = 1, ["23989"] = 1, ["24227"] = 1, ["23663"] = 1, ["23664"] = 1, ["23661"] = 1, ["23662"] = 1, ["23671"] = 1, ["23842"] = 1, ["23911"] = 1, ["23937"] = 1, ["24151"] = 1, ["23728"] = 1, ["24525"] = 1, ["24642"] = 1, ["24874"] = 1, ["24876"] = 1, ["24877"] = 1, ["24875"] = 1, ["24283"] = 1, ["24333"] = 1, ["23967"] = 1, ["24328"] = 1, ["24062"] = 1, ["24050"] = 1, ["23844"] = 1, ["24532"] = 1, ["24531"] = 1, ["24131"] = 1, ["24139"] = 1, ["24052"] = 1, ["24718"] = 1, ["24806"] = 1, ["24821"] = 1, ["24823"] = 1, ["24825"] = 1, ["24852"] = 1, ["24720"] = 1, ["24717"] = 1, ["23931"] = 1, ["31812"] = 1, ["24213"] = 1, ["24214"] = 1, ["24215"] = 1, ["24176"] = 1, ["23548"] = 1, ["23975"] = 1, ["23546"] = 1, ["23732"] = 1, ["23823"] = 1, ["27570"] = 1, ["23734"] = 1, ["24332"] = 1, ["24233"] = 1, ["24315"] = 1, ["24314"] = 1, ["24027"] = 1, 

-- Drachende / Dragonblight
	["27355"] = 1, ["27567"] = 1, ["26917"] = 1, ["31333"] = 1, ["31334"] = 1, ["27005"] = 1, ["27006"] = 1, ["27857"] = 1, ["27858"] = 1, ["27872"] = 1, ["27002"] = 1, ["26349"] = 1, ["27225"] = 1, ["27577"] = 1, ["27588"] = 1, ["27713"] = 1, ["27316"] = 1, ["27996"] = 1, ["27844"] = 1, ["27007"] = 1, ["27009"] = 1, ["27008"] = 1, ["27003"] = 1, ["27953"] = 1, ["27171"] = 1, ["26473"] = 1, ["26661"] = 1, ["27315"] = 1, ["27336"] = 1, ["27683"] = 1, ["27510"] = 1, ["27784"] = 1, ["26593"] = 1, ["27355"] = 1, ["27210"] = 1, ["26762"] = 1, ["27506"] = 1, ["27687"] = 1, ["26608"] = 1, ["26496"] = 1, ["26280"] = 1, ["27951"] = 1, ["27990"] = 1, ["27159"] = 1, ["27356"] = 1, ["28006"] = 1, ["27290"] = 1, ["27335"] = 1, ["27383"] = 1, ["27359"] = 1, ["27314"] = 1, ["27156"] = 1, ["27163"] = 1, ["27220"] = 1, ["27476"] = 1, ["27492"] = 1, ["27455"] = 1, ["27480"] = 1, ["27229"] = 1, ["27220"] = 1, ["27226"] = 1, ["27880"] = 1, ["26648"] = 1, ["27662"] = 1, ["27136"] = 1, ["45425"] = 1, ["34924"] = 1, ["27788"] = 1, ["27224"] = 1, 

-- Dun Morogh / Dun Morogh
	["1378"] = 1, ["37081"] = 1, ["37073"] = 1, ["37087"] = 1, ["37108"] = 1, ["37174"] = 1, ["37173"] = 1, ["37507"] = 1, ["808"] = 1, ["37112"] = 1, ["6782"] = 1, ["37113"] = 1, ["40950"] = 1, ["41335"] = 1, ["40991"] = 1, ["40994"] = 1, ["41056"] = 1, ["1269"] = 1, ["1377"] = 1, ["41175"] = 1, ["41251"] = 1, ["41611"] = 1, ["41578"] = 1, ["1263"] = 1, ["1115"] = 1, ["41671"] = 1, ["1360"] = 1, ["6123"] = 1, ["42010"] = 1, ["45847"] = 1, 

-- Dunkelkste
	["4190"] = 1, ["2917"] = 1, ["10216"] = 1, ["3899"] = 1, ["12321"] = 1, ["32978"] = 1, ["3694"] = 1, ["32959"] = 1, ["33093"] = 1, ["33181"] = 1, ["3583"] = 1, ["33096"] = 1, 

-- Dunkelmond Insel / Dunkelmondjahrmarkt
	["55270"] = 1, ["55269"] = 1, ["14844"] = 1, ["54518"] = 1, ["54485"] = 1, ["23988"] = 1, ["14845"] = 1, ["55266"] = 1, ["14828"] = 1, ["55264"] = 1, ["10445"] = 1, ["14841"] = 1, ["55248"] = 1, ["55249"] = 1, ["55247"] = 1, ["15303"] = 1, ["54601"] = 1, ["54605"] = 1, ["55396"] = 1, ["54345"] = 1, ["14823"] = 1, ["54596"] = 1, ["54595"] = 1, ["14847"] = 1, ["54489"] = 1, ["55339"] = 1, ["68492"] = 1, 

-- Dstermarschen
	["12936"] = 1, ["23786"] = 1, ["12938"] = 1, ["4948"] = 1, ["23720"] = 1, ["23843"] = 1, ["23861"] = 1, ["23864"] = 1, ["4895"] = 1, ["23567"] = 1, ["5088"] = 1, ["23569"] = 1, ["4944"] = 1, ["10036"] = 1, ["51919"] = 1,	["23789"] = 1, ["2616"] = 1, ["23602"] = 1, ["23573"] = 1, ["23995"] = 1, ["23579"] = 1, ["23600"] = 1, ["4973"] = 1, ["23566"] = 1, ["4979"] = 1, ["51924"] = 1, ["23941"] = 1, ["23905"] = 1, ["23900"] = 1, ["55271"] = 1, ["23896"] = 1, ["4792"] = 1, ["4968"] = 1, 

-- Hgel der Klingenhauer / Razorfen Kraul
	["8567"] = 1, ["7358"] = 1, ["7357"] = 1, ["44843"] = 1, 

-- Eschental
	["47366"] = 1, ["47339"] = 1, ["3663"] = 1, ["33347"] = 1, ["4509"] = 1, ["3916"] = 1, ["3894"] = 1, ["3892"] = 1, ["3847"] = 1, 

-- Eiskrone
	["30954"] = 1, ["31160"] = 1, ["30989"] = 1, ["30920"] = 1, ["31226"] = 1, ["32300"] = 1, ["32236"] = 1, ["31833"] = 1, ["33522"] = 1, ["30350"] = 1, ["31737"] = 1, ["30708"] = 1, ["31235"] = 1, ["31428"] = 1, ["30631"] = 1, ["31432"] = 1, ["29405"] = 1, ["31279"] = 1, ["32800"] = 1, ["32642"] = 1, ["35501"] = 1, ["35116"] = 1, ["35474"] = 1, ["30037"] = 1, ["38505"] = 1, ["30186"] = 1, ["30194"] = 1, ["30195"] = 1, ["30196"] = 1, ["35476"] = 1, ["29880"] = 1, ["30250"] = 1, ["30081"] = 1, ["33785"] = 1, ["33546"] = 1, ["35444"] = 1, ["29919"] = 1, ["30225"] = 1, ["31067"] = 1, ["30377"] = 1, ["30596"] = 1, ["30243"] = 1, ["30632"] = 1, ["33481"] = 1, ["33559"] = 1, ["33565"] = 1, ["33383"] = 1, ["33564"] = 1, ["33463"] = 1, ["33558"] = 1, ["33306"] = 1, ["33460"] = 1, ["33285"] = 1, ["33476"] = 1, ["33382"] = 1, ["33468"] = 1, ["33479"] = 1, ["33561"] = 1, ["33384"] = 1, ["33469"] = 1, ["33417"] = 1, ["33748"] = 1, ["33477"] = 1, ["33747"] = 1, ["33480"] = 1, ["33743"] = 1, ["33467"] = 1, ["33746"] = 1, ["33740"] = 1, ["33853"] = 1, ["31690"] = 1, ["32222"] = 1, ["30656"] = 1, ["31258"] = 1, ["31691"] = 1, ["31240"] = 1, ["31259"] = 1, ["31241"] = 1, ["31135"] = 1, ["30189"] = 1, ["30672"] = 1, ["31033"] = 1, ["30224"] = 1, ["31003"] = 1, ["31063"] = 1, ["30840"] = 1, ["30839"] = 1, ["30714"] = 1, ["30686"] = 1, ["30226"] = 1, ["30683"] = 1, ["30274"] = 1, ["30407"] = 1,

-- Eiskronenzitadelle
	["37503"] = 1, ["38472"] = 1, ["38485"] = 1, ["36853"] = 1, ["37955"] = 1, ["38004"] = 1, ["37007"] = 1, ["36789"] = 1, ["37122"] = 1, ["37126"] = 1, ["37038"] = 1, ["37123"] = 1, ["38501"] = 1, ["36678"] = 1, ["36626"] = 1, ["36855"] = 1, ["36612"] = 1, ["37813"] = 1, ["37125"] = 1, ["37129"] = 1, ["37124"] = 1, ["28410"] = 1, ["36939"] = 1, ["37187"] = 1, ["36998"] = 1, ["37026"] = 1, ["37116"] = 1, ["37003"] = 1, ["37016"] = 1, ["37017"] = 1, ["36627"] = 1, ["37597"] = 1, 

-- Eisenschmiede
	["9616"] = 1, ["4081"] = 1, ["7978"] = 1, ["5109"] = 1,["42129"] = 1, ["42928"] = 1, ["42131"] = 1, ["42130"] = 1, ["2918"] = 1, ["42153"] = 1, ["5595"] = 1, ["6175"] = 1, 

-- Feralas
	["5241"] = 1, ["5240"] = 1, ["5234"] = 1, ["5236"] = 1,

-- Gebirgspass der Totenwinde
	["14889"] = 1,

-- Grizzlyhgel / Grizzly Hills
	["26582"] = 1, ["26919"] = 1, ["27017"] = 1, ["27212"] = 1, ["31625"] = 1, ["28063"] = 1, ["29384"] = 1, ["30190"] = 1, ["30035"] = 1, ["29369"] = 1, ["26932"] = 1, ["27624"] = 1, ["26935"] = 1, ["26971"] = 1, ["27646"] = 1, ["27411"] = 1, ["27115"] = 1, ["26604"] = 1, ["26544"] = 1, ["27497"] = 1, ["26361"] = 1, ["26422"] = 1, ["27277"] = 1, ["27071"] = 1, ["27113"] = 1, ["27114"] = 1, ["27115"] = 1, ["26377"] = 1, ["26226"] = 1, ["26334"] = 1, ["26282"] = 1, ["26811"] = 1, ["29277"] = 1, ["26783"] = 1, ["26921"] = 1, ["26922"] = 1, ["26923"] = 1, ["26920"] = 1, ["26786"] = 1, ["26417"] = 1, ["12085"] = 1, ["26484"] = 1, ["26812"] = 1, ["26814"] = 1, ["26205"] = 1, ["26392"] = 1, ["29285"] = 1, ["26371"] = 1, ["62663"] = 1, ["26604"] = 1, ["26500"] = 1, ["26543"] = 1, ["26701"] = 1, ["26787"] = 1, ["26604"] = 1, ["26583"] = 1, ["26626"] = 1, ["27556"] = 1, ["26588"] = 1, 

-- Gundrak / Gundrak
	["29305"] = 1, ["29306"] = 1, ["20394"] = 1, 

-- Ahn'kahet / Ahn'kahet
	["29309"] = 1, ["29308"] = 1, ["29311"] = 1, ["55658"] = 1, ["29310"] = 1, 

-- Hhlen der Zeit
	["32273"] = 1, ["19918"] = 1, ["32281"] = 1, ["20201"] = 1, ["17023"] = 1,

-- Feste Drak'Tharon / Drak'Tharon Keep
	["26635"] = 1, ["26631"] = 1, ["26632"] = 1, ["28016"] = 1, ["28498"] = 1, 

-- Hllenfeuerzitadelle / Hellfire Citadel
	["17270"] = 1, ["17308"] = 1, ["17257"] = 1, ["17381"] = 1, ["17380"] = 1, ["17653"] = 1, ["17397"] = 1, ["17377"] = 1, ["17429"] = 1, ["17455"] = 1, ["17306"] = 1, ["17307"] = 1, ["17537"] = 1, ["17271"] = 1, ["17264"] = 1, ["21504"] = 1, ["17414"] = 1, ["17269"] = 1, ["17478"] = 1, ["17259"] = 1, ["17258"] = 1, ["24918"] = 1, ["16819"] = 1, 

-- Hllenfeuerhalbinsel / Hellfire Peninsula
	["19445"] = 1, ["16834"] = 1, ["17000"] = 1, ["20232"] = 1, ["19316"] = 1, ["20679"] = 1, ["20677"] = 1, ["20678"] = 1, ["19477"] = 1, ["20157"] = 1, ["16938"] = 1, ["17058"] = 1, ["16833"] = 1, ["16799"] = 1, ["16836"] = 1, ["19764"] = 1, ["19766"] = 1, ["19354"] = 1, ["19294"] = 1, ["24918"] = 1, ["18952"] = 1, ["16821"] = 1, ["23170"] = 1, ["23171"] = 1, ["19308"] = 1, ["16842"] = 1, ["20513"] = 1, ["51800"] = 1, ["51801"] = 1, ["51804"] = 1, ["18728"] = 1, ["16819"] = 1, ["19392"] = 1, ["22374"] = 1, ["16825"] = 1, ["16886"] = 1, ["22430"] = 1, ["16826"] = 1, ["19191"] = 1, ["19446"] = 1, ["21133"] = 1, ["21134"] = 1, ["22454"] = 1, ["22432"] = 1, ["22431"] = 1, ["16864"] = 1, ["19354"] = 1, ["21504"] = 1, ["16907"] = 1, ["3230"] = 1, 

-- Hyjal / Mount Hyjal
	["40551"] = 1, ["41255"] = 1, ["41008"] = 1, ["41243"] = 1, ["41287"] = 1, ["50083"] = 1, ["51777"] = 1, ["40814"] = 1, ["40816"] = 1, ["40773"] = 1, ["40803"] = 1, ["41631"] = 1, ["52931"] = 1, ["40793"] = 1, ["41634"] = 1, ["39857"] = 1, ["40804"] = 1, ["41632"] = 1, ["39858"] = 1, ["40805"] = 1, ["41480"] = 1, ["41630"] = 1, ["52838"] = 1, ["52932"] = 1, ["40982"] = 1, ["41308"] = 1, ["40955"] = 1, ["49450"] = 1, ["39974"] = 1, ["40185"] = 1, ["40562"] = 1, ["39621"] = 1, ["39749"] = 1, ["40563"] = 1, ["40619"] = 1, ["40772"] = 1, ["52902"] = 1, ["40289"] = 1, ["40928"] = 1, ["49446"] = 1, ["52793"] = 1, ["54172"] = 1, ["39446"] = 1, ["39644"] = 1, ["39756"] = 1, ["39765"] = 1, ["39646"] = 1, ["39640"] = 1, ["39843"] = 1, ["40845"] = 1, ["40844"] = 1, ["38806"] = 1, ["40148"] = 1, ["39921"] = 1, ["39926"] = 1, ["41068"] = 1, ["41112"] = 1, ["41114"] = 1, ["41005"] = 1, ["41089"] = 1, ["41006"] = 1, ["41234"] = 1, ["52907"] = 1, ["47002"] = 1, ["39437"] = 1, ["39627"] = 1, ["39846"] = 1, ["46987"] = 1, ["39933"] = 1, ["40107"] = 1, ["40172"] = 1, ["46998"] = 1, ["41406"] = 1, ["41499"] = 1, ["41500"] = 1, ["41563"] = 1, ["41614"] = 1, ["39619"] = 1, ["39453"] = 1, ["39828"] = 1, ["39752"] = 1, ["40491"] = 1, ["40409"] = 1, ["44814"] = 1, 

-- Karazhan
	["16409"] = 1, ["16408"] = 1, ["15687"] = 1, ["16457"] = 1, ["17534"] = 1, ["17533"] = 1, ["16470"] = 1, ["16426"] = 1, ["17651"] = 1, ["17652"] = 1, ["17225"] = 1, ["15691"] = 1, ["15688"] = 1, ["16524"] = 1, ["15690"] = 1, ["15551"] = 1, ["16504"] = 1, ["16544"] = 1, ["16545"] = 1, ["16406"] = 1, ["16481"] = 1, ["16389"] = 1, ["16812"] = 1, ["16482"] = 1, ["18255"] = 1, ["18253"] = 1, ["17613"] = 1, ["16159"] = 1, ["16407"] = 1, ["16414"] = 1, ["16471"] = 1, ["16460"] = 1, ["16459"] = 1, ["16461"] = 1, ["16425"] = 1, ["16468"] = 1, ["16472"] = 1, ["16473"] = 1, ["16410"] = 1, ["16540"] = 1, 

-- Krater von Ungoro
	["28601"] = 1, ["9997"] = 1, ["9117"] = 1, ["14461"] = 1,

-- Loch Modan
	["1175"] = 1, ["1165"] = 1, ["1167"] = 1, ["1172"] = 1, ["1162"] = 1, ["1197"] = 1, ["1164"] = 1, ["1177"] = 1, ["1174"] = 1, ["44262"] = 1, ["1379"] = 1, ["1981"] = 1, ["1380"] = 1, ["2057"] = 1, ["3671"] = 1, ["3669"] = 1, 

-- Mulgore
	["23618"] = 1,

-- Mondlichtung
	["22834"] = 1, ["22916"] = 1, ["22915"] = 1, ["11832"] = 1, ["15961"] = 1, ["39128"] = 1, 

-- Nagrand / Nagrand
	["22981"] = 1, ["18400"] = 1, ["18069"] = 1, ["18401"] = 1, ["18211"] = 1, ["18218"] = 1, ["18182"] = 1, ["18109"] = 1, ["18428"] = 1, ["18440"] = 1, ["18396"] = 1, ["18063"] = 1, ["18417"] = 1, ["23348"] = 1, ["22083"] = 1, ["19149"] = 1, ["18408"] = 1, ["19035"] = 1, ["18688"] = 1, ["18488"] = 1, ["18445"] = 1, ["18369"] = 1, ["20812"] = 1, ["18265"] = 1, ["19667"] = 1, ["22836"] = 1, ["18471"] = 1, ["18274"] = 1, ["18391"] = 1, ["18109"] = 1, ["18351"] = 1, ["18400"] = 1, 

-- Nethersturm 
	["20448"] = 1, ["22900"] = 1, ["20456"] = 1, ["20551"] = 1, ["20552"] = 1, ["20603"] = 1, ["20452"] = 1, ["20787"] = 1, ["20553"] = 1, ["20482"] = 1, ["20854"] = 1, ["20913"] = 1, ["20281"] = 1, ["20133"] = 1, ["20393"] = 1, ["19469"] = 1, ["20780"] = 1, ["19851"] = 1, ["19776"] = 1, ["19570"] = 1, ["19737"] = 1, ["19545"] = 1, ["19546"] = 1, ["19832"] = 1, ["19543"] = 1, ["19544"] = 1, ["19634"] = 1, ["20145"] = 1, ["20464"] = 1, ["19481"] = 1, ["20218"] = 1, ["19738"] = 1, ["19589"] = 1, ["19578"] = 1, ["19623"] = 1, ["19617"] = 1, ["19621"] = 1, ["19612"] = 1, ["19541"] = 1, ["19493"] = 1, ["19610"] = 1, ["19217"] = 1, ["21751"] = 1, ["21925"] = 1, ["19534"] = 1, ["19535"] = 1, ["19467"] = 1, ["19466"] = 1, ["19468"] = 1, ["19645"] = 1, ["19533"] = 1, ["20242"] = 1, ["19635"] = 1, ["19218"] = 1, ["19219"] = 1, ["19220"] = 1, ["20885"] = 1, ["20886"] = 1, ["20904"] = 1, ["20909"] = 1, ["20910"] = 1, ["20912"] = 1, ["21466"] = 1, ["21467"] = 1,

-- Ogrimmar
	["14392"] = 1, ["47335"] = 1, ["47336"] = 1, ["42671"] = 1, ["42650"] = 1, ["42638"] = 1, ["35068"] = 1, ["9564"] = 1, ["12136"] = 1, ["34765"] = 1, ["26537"] = 1, ["25070"] = 1, ["25077"] = 1, 

-- dland / Badlands
	["46695"] = 1, ["46460"] = 1, ["2920"] = 1, ["4618"] = 1, ["47123"] = 1, ["47126"] = 1, ["8581"] = 1, ["47125"] = 1, ["47124"] = 1, ["2718"] = 1, ["2718"] = 1, ["46654"] = 1, ["46664"] = 1, ["46769"] = 1, ["46768"] = 1, ["46833"] = 1, ["46861"] = 1, 

-- stliche Pestlnder / Eastern Plaguelands
	["16114"] = 1, ["28486"] = 1, ["27928"] = 1, ["29194"] = 1, ["45445"] = 1, ["45417"] = 1, ["46173"] = 1, ["46178"] = 1, ["45941"] = 1, ["45431"] = 1, ["11288"] = 1, ["11289"] = 1, ["10817"] = 1, ["46194"] = 1, ["10940"] = 1, ["10926"] = 1, ["11296"] = 1, ["10948"] = 1, ["10944"] = 1, ["10950"] = 1, ["10939"] = 1, ["45707"] = 1, ["16378"] = 1, ["47060"] = 1, ["51986"] = 1, ["46094"] = 1, ["46095"] = 1, ["46096"] = 1, ["45744"] = 1, ["10824"] = 1, ["17878"] = 1, ["11038"] = 1, ["46093"] = 1, 

-- Quel Danas 
	["25160"] = 1, ["25032"] = 1, ["24813"] = 1, ["24966"] = 1, ["24960"] = 1, ["24967"] = 1, ["24965"] = 1, ["25046"] = 1, ["25155"] = 1, ["25115"] = 1, ["25069"] = 1, ["24882"] = 1, ["25164"] = 1, ["25162"] = 1, ["26560"] = 1, ["24976"] = 1, ["25059"] = 1, ["25132"] = 1, ["25144"] = 1, ["25153"] = 1, ["25133"] = 1, ["25034"] = 1, ["24938"] = 1,

-- Rotkammgebirge / Redridge Mountains
	["4064"] = 1, ["568"] = 1, ["615"] = 1, ["6166"] = 1, ["446"] = 1, ["349"] = 1, ["4463"] = 1, 

-- Schattenhochland / Twillight Highlands
	["48197"] = 1, ["52025"] = 1, ["45644"] = 1, ["45986"] = 1, ["46732"] = 1, ["46899"] = 1, ["46332"] = 1, ["46331"] = 1, ["46785"] = 1, ["45432"] = 1, ["46243"] = 1, ["46472"] = 1, ["47999"] = 1, ["46611"] = 1, ["46579"] = 1, ["46343"] = 1, ["45675"] = 1, ["46323"] = 1, ["46386"] = 1, ["46893"] = 1, ["46342"] = 1, ["46341"] = 1, ["46143"] = 1, ["46628"] = 1, ["49274"] = 1, ["49362"] = 1, ["46176"] = 1, ["46615"] = 1, ["46626"] = 1, ["49314"] = 1, ["49369"] = 1, ["46174"] = 1, ["46616"] = 1, ["46625"] = 1, ["46322"] = 1, ["46175"] = 1, ["46553"] = 1, ["46583"] = 1, ["46585"] = 1, ["46627"] = 1, ["49276"] = 1, ["49364"] = 1, ["46137"] = 1, ["46163"] = 1, ["46900"] = 1, ["48010"] = 1, ["48175"] = 1, ["46591"] = 1, ["48173"] = 1, ["48472"] = 1, ["49273"] = 1, ["49361"] = 1, ["46320"] = 1, ["46377"] = 1, ["49278"] = 1, ["49367"] = 1, ["48053"] = 1, ["47465"] = 1, ["46984"] = 1, ["46813"] = 1, ["47229"] = 1, ["45171"] = 1, ["46949"] = 1, ["50641"] = 1, ["46831"] = 1, ["46804"] = 1, ["48364"] = 1, ["48500"] = 1, ["49271"] = 1, ["49359"] = 1, ["46935"] = 1, ["46945"] = 1, ["48383"] = 1, ["46947"] = 1, ["47512"] = 1, ["46948"] = 1, ["48381"] = 1, ["46342"] = 1, ["45518"] = 1, ["45708"] = 1, ["46418"] = 1, ["46456"] = 1, ["47902"] = 1, ["49417"] = 1, ["50360"] = 1, ["45210"] = 1, ["45183"] = 1, ["45770"] = 1, ["21330"] = 1, ["45167"] = 1, ["45668"] = 1, ["46895"] = 1, ["48365"] = 1, ["49270"] = 1, ["49358"] = 1, ["45173"] = 1, ["46807"] = 1, ["46922"] = 1, ["46923"] = 1, ["47199"] = 1, ["50426"] = 1, ["45524"] = 1, ["45172"] = 1, 

-- Schattenmondtal / Shadowmoon Valley
	["21718"] = 1, ["23283"] = 1, ["23311"] = 1, ["22252"] = 1, ["21717"] = 1, ["21739"] = 1, ["22274"] = 1, ["23440"] = 1, ["23441"] = 1, ["21648"] = 1, ["21699"] = 1, ["22989"] = 1, ["21295"] = 1, ["21453"] = 1, ["21164"] = 1, ["21024"] = 1, ["21867"] = 1, ["21402"] = 1, ["19806"] = 1, ["22016"] = 1, ["22012"] = 1, ["21773"] = 1, ["19362"] = 1, ["51910"] = 1, ["21049"] = 1, ["19394"] = 1, ["19395"] = 1, ["22059"] = 1, ["23139"] = 1, ["23452"] = 1, ["23434"] = 1, ["17711"] = 1, ["21181"] = 1, ["21685"] = 1, ["21183"] = 1, ["22054"] = 1, ["22113"] = 1, ["22083"] = 1, ["21657"] = 1, ["21795"] = 1, ["21775"] = 1, 

-- Schergrat / Blade's Edge Mountains
	["22924"] = 1, ["23243"] = 1, ["23241"] = 1, ["22103"] = 1, ["22473"] = 1, ["20555"] = 1, ["21514"] = 1, ["22423"] = 1, ["19747"] = 1, ["21046"] = 1, ["21047"] = 1, ["22396"] = 1, ["22007"] = 1, ["21983"] = 1, ["19994"] = 1, ["20726"] = 1, ["21945"] = 1, ["22465"] = 1, ["20753"] = 1, ["21975"] = 1, ["19996"] = 1, ["21296"] = 1, ["20334"] = 1, ["20756"] = 1, ["19998"] = 1, ["22910"] = 1, ["23218"] = 1, ["23217"] = 1, ["21441"] = 1, ["21114"] = 1, ["21118"] = 1, ["21427"] = 1, ["19948"] = 1, ["20095"] = 1, ["22982"] = 1, ["23392"] = 1, ["23208"] = 1, ["23430"] = 1, ["23120"] = 1, ["23365"] = 1, ["23334"] = 1, ["23115"] = 1, ["19997"] = 1, ["23335"] = 1, ["23354"] = 1, ["22941"] = 1, ["19957"] = 1, ["21469"] = 1, ["21151"] = 1, ["21197"] = 1, ["21277"] = 1, ["19995"] = 1, ["18098"] = 1, ["21690"] = 1, ["21114"] = 1, 

-- Schlingendorntal / Stranglethorn Vale
	["52767"] = 1, ["2496"] = 1, ["52053"] = 1, ["53078"] = 1, ["53180"] = 1, ["1387"] = 1, ["53008"] = 1, ["42790"] = 1, ["42941"] = 1, ["52151"] = 1, ["52234"] = 1, ["52654"] = 1, ["53081"] = 1, ["52059"] = 1, ["2634"] = 1, ["15077"] = 1, ["1493"] = 1, ["15077"] = 1, ["43920"] = 1, ["43919"] = 1, ["43921"] = 1, ["739"] = 1, ["43913"] = 1, ["43912"] = 1, ["43885"] = 1, ["43886"] = 1, ["43910"] = 1, ["679"] = 1, ["1059"] = 1, ["2530"] = 1, ["678"] = 1, ["14508"] = 1, 

-- Sengende Schlucht / Searing Gorge
	["8421"] = 1, ["9876"] = 1, ["14636"] = 1, ["8480"] = 1, ["8509"] = 1, ["14635"] = 1, ["47270"] = 1, ["47299"] = 1, ["47271"] = 1, ["47301"] = 1, ["14636"] = 1, ["5840"] = 1, ["8419"] = 1, ["5843"] = 1, ["8391"] = 1, ["14627"] = 1, ["47462"] = 1, 

-- Shattrath
	["19196"] = 1, ["21411"] = 1, ["18166"] = 1, ["19142"] = 1, ["19685"] = 1, ["24393"] = 1, ["24416"] = 1, ["19283"] = 1, ["19270"] = 1, ["18585"] = 1, ["19216"] = 1, ["25141"] = 1, ["19202"] = 1, ["18481"] = 1, ["17076"] = 1, ["25167"] = 1, ["19475"] = 1, ["25885"] = 1, ["19664"] = 1, ["19223"] = 1, ["22940"] = 1, ["19227"] = 1, ["19377"] = 1, ["19164"] = 1, ["18549"] = 1, ["19346"] = 1, ["19378"] = 1, ["19138"] = 1, ["18537"] = 1, 

-- Sholazarbecken
	["28103"] = 1, ["29043"] = 1, ["28139"] = 1, ["28214"] = 1, ["28668"] = 1, ["28604"] = 1, ["28054"] = 1, ["28787"] = 1, ["28123"] = 1, ["28124"] = 1, ["28229"] = 1, ["28256"] = 1, ["28266"] = 1, ["28092"] = 1, ["28215"] = 1, ["28374"] = 1, ["28376"] = 1, ["28033"] = 1, ["28095"] = 1, ["28328"] = 1, ["28047"] = 1, ["27986"] = 1, ["28451"] = 1, ["28568"] = 1, ["28646"] = 1, 

-- Silithus
	["15189"] = 1, ["15211"] = 1, ["15190"] = 1,

-- Sklavenunterknfte
	["18206"] = 1, ["17893"] = 1, ["17957"] = 1, ["17963"] = 1, ["17964"] = 1, ["17958"] = 1, 

-- Steinkrallengebirge
	["42032"] = 1, ["41673"] = 1, ["41780"] = 1, ["42105"] = 1, ["42125"] = 1, ["41360"] = 1, ["34933"] = 1, ["34934"] = 1, ["34941"] = 1, ["34940"] = 1, ["34939"] = 1, ["34937"] = 1, ["11917"] = 1, ["42026"] = 1,

-- Sturmwind / Stormwind
	["54117"] = 1, ["54119"] = 1, ["29152"] = 1, ["44814"] = 1, ["44815"] = 1, ["44816"] = 1, ["44806"] = 1, ["50135"] = 1, ["2439"] = 1, ["1747"] = 1, ["42021"] = 1, ["1405"] = 1, ["1371"] = 1, ["8856"] = 1, ["1427"] = 1, ["3520"] = 1, ["3513"] = 1, ["2198"] = 1, ["1428"] = 1, ["8666"] = 1, ["1395"] = 1, ["1289"] = 1, ["7766"] = 1, ["1756"] = 1, ["1212"] = 1, ["5484"] = 1, ["12336"] = 1, ["12997"] = 1, ["7917"] = 1, ["1433"] = 1, ["1257"] = 1, ["1432"] = 1, ["14423"] = 1, ["5124"] = 1, ["1291"] = 1, ["2330"] = 1, ["1367"] = 1, ["1413"] = 1, ["1370"] = 1, ["1368"] = 1, ["279"] = 1, ["1295"] = 1, ["1286"] = 1, ["482"] = 1, ["14394"] = 1, ["6174"] = 1, ["1285"] = 1, ["12480"] = 1, ["1402"] = 1, ["3518"] = 1, ["2533"] = 1, ["2532"] = 1, ["3504"] = 1, ["12481"] = 1, ["3627"] = 1, ["1478"] = 1, ["1477"] = 1, ["12580"] = 1, ["46410"] = 1, ["5042"] = 1, ["1719"] = 1, ["46409"] = 1, ["14497"] = 1, ["1414"] = 1, ["1415"] = 1, ["1749"] = 1, ["466"] = 1, ["1366"] = 1, ["1976"] = 1, ["68"] = 1, ["1287"] = 1, ["45014"] = 1, ["1275"] = 1, ["53949"] = 1, ["8719"] = 1,  ["54021"] = 1, ["54118"] = 1, ["54072"] = 1,  ["44395"] = 1, ["53991"] = 1, ["6740"] = 1, ["44238"] = 1, ["43769"] = 1, ["43768"] = 1, ["63596"] = 1, ["14721"] = 1, ["44241"] = 1, ["44239"] = 1, ["44243"] = 1, ["55483"] = 1, ["61895"] = 1, ["61896"] = 1, ["61834"] = 1, ["61835"] = 1, ["61836"] = 1, ["61838"] = 1, ["61837"] = 1, ["5564"] = 1, ["61839"] = 1, ["61840"] = 1, ["61841"] = 1, ["61796"] = 1, ["61792"] = 1, ["42059"] = 1, ["42103"] = 1, ["39460"] = 1, 

-- Sturmgipfel / Storm Peaks
	["29650"] = 1, ["29626"] = 1, ["29981"] = 1, ["29429"] = 1, ["30012"] = 1, ["30147"] = 1, ["30154"] = 1, ["29525"] = 1, ["30146"] = 1, ["29466"] = 1, ["30396"] = 1, ["28923"] = 1, ["29643"] = 1, ["29644"] = 1, ["29434"] = 1, ["29564"] = 1, ["29433"] = 1, ["29555"] = 1, 

-- Sumpfland
	["1476"] = 1, ["42044"] = 1, 

-- Sderstade
	["44995"] = 1, ["2277"] = 1, ["15199"] = 1, ["2364"] = 1, ["3980"] = 1,

-- Tanaris
	["38534"] = 1, ["38703"] = 1, ["38849"] = 1, ["40542"] = 1, ["40875"] = 1, ["39034"] = 1, ["38535"] = 1, ["38704"] = 1, ["39059"] = 1, ["40547"] = 1, ["40876"] = 1, ["46479"] = 1, ["38706"] = 1, ["11811"] = 1, ["5472"] = 1, ["5473"] = 1, ["5474"] = 1, ["39082"] = 1, ["7902"] = 1, ["7899"] = 1, ["7918"] = 1, ["9453"] = 1, ["7607"] = 1, ["7604"] = 1, ["26529"] = 1, ["27913"] = 1, ["27903"] = 1, ["27907"] = 1, ["30571"] = 1, 

-- Tausend Nadeln
	["48996"] = 1, ["49157"] = 1,

-- Tausendwinter
	["31051"] = 1, ["31091"] = 1, ["31108"] = 1, ["31036"] = 1, ["31109"] = 1, ["31052"] = 1,

-- Teldrassil
	["2083"] = 1, ["6286"] = 1,

-- Teufelswald
	["11141"] = 1,

-- Tiefenheim
	["43168"] = 1, ["43635"] = 1, ["45064"] = 1, ["44143"] = 1, ["47195"] = 1, ["44835"] = 1, ["45028"] = 1, ["43391"] = 1, ["42695"] = 1, ["42188"] = 1, ["42333"] = 1, ["45099"] = 1, ["43026"] = 1, ["42747"] = 1, ["43082"] = 1, ["42801"] = 1, ["42892"] = 1, ["42965"] = 1, ["42964"] = 1, ["44768"] = 1, ["43160"] = 1, ["44372"] = 1, ["43138"] = 1, ["43456"] = 1, ["43229"] = 1, ["43897"] = 1, ["43984"] = 1, ["44152"] = 1, ["44153"] = 1, ["44956"] = 1, ["42731"] = 1, ["42788"] = 1, 
	["44353"] = 1, ["44352"] = 1, ["42471"] = 1, ["42917"] = 1, ["42468"] = 1, ["42467"] = 1, ["43802"] = 1, ["42466"] = 1, ["43503"] = 1, ["43372"] = 1, ["42465"] = 1, ["43901"] = 1, ["45034"] = 1, ["44631"] = 1, ["43836"] = 1, ["42923"] = 1, ["42914"] = 1, ["44673"] = 1, ["43837"] = 1, ["43792"] = 1, ["43835"] = 1, ["44666"] = 1,  

-- Tirisfal
	["3150"] = 1, ["26539"] = 1,

-- Ulduar
	["33113"] = 1, ["33293"] = 1, ["33287"] = 1, ["34145"] = 1, ["33210"] = 1, ["33118"] = 1, ["33696"] = 1, ["33662"] = 1, ["33267"] = 1, ["33624"] = 1, ["28160"] = 1, ["33686"] = 1, ["33626"] = 1, ["33701"] = 1, ["33235"] = 1, ["33579"] = 1, ["34064"] = 1, ["34119"] = 1,
 
-- Uldum / Uldum
	["39788"] = 1, ["47251"] = 1, ["47670"] = 1, ["47461"] = 1, ["47516"] = 1, ["47967"] = 1, ["47984"] = 1, ["47193"] = 1, ["47364"] = 1, ["47947"] = 1, ["46134"] = 1, ["49183"] = 1, ["49383"] = 1, ["46883"] = 1, ["48237"] = 1, ["48761"] = 1, ["49345"] = 1, ["46333"] = 1, ["46886"] = 1, ["47159"] = 1, ["47160"] = 1, ["47249"] = 1, ["47940"] = 1, ["47957"] = 1, ["47972"] = 1, ["49466"] = 1, ["49467"] = 1, ["47292"] = 1, ["49244"] = 1, ["49253"] = 1, ["45949"] = 1, ["49148"] = 1, ["46425"] = 1, ["44860"] = 1, ["45143"] = 1, ["45180"] = 1, ["45238"] = 1, ["45275"] = 1, ["45296"] = 1, ["46978"] = 1, ["47050"] = 1, ["47158"] = 1, ["48034"] = 1, ["48045"] = 1, ["48082"] = 1, ["48162"] = 1, ["48186"] = 1, ["48528"] = 1, ["48547"] = 1, ["48558"] = 1, ["48604"] = 1, ["48698"] = 1, ["48703"] = 1, ["49151"] = 1, ["49203"] = 1, ["49247"] = 1, ["49353"] = 1, ["46781"] = 1, ["46873"] = 1, ["47005"] = 1, ["48028"] = 1, ["48030"] = 1, ["47285"] = 1, ["47451"] = 1, ["47306"] = 1, ["47567"] = 1, ["45799"] = 1, ["46872"] = 1, ["47896"] = 1, ["47959"] = 1, ["48987"] = 1, ["46042"] = 1, ["45715"] = 1, ["47014"] = 1, ["53524"] = 1, 

-- Vashj'ir / Vashj'ir
	["37008"] = 1, ["39313"] = 1, ["40782"] = 1, ["40753"] = 1, ["40759"] = 1, ["40770"] = 1, ["41764"] = 1, ["41781"] = 1, ["41805"] = 1, ["41808"] = 1, ["43176"] = 1, ["43180"] = 1, ["36915"] = 1, ["40105"] = 1, ["40697"] = 1, ["40736"] = 1, ["40746"] = 1, ["41341"] = 1, ["41600"] = 1, ["41751"] = 1, ["41777"] = 1, ["41794"] = 1, ["41869"] = 1, ["42261"] = 1, ["43519"] = 1, ["43908"] = 1, ["44518"] = 1, ["40677"] = 1, ["40810"] = 1, ["40811"] = 1, ["40786"] = 1, ["40797"] = 1, ["41809"] = 1, ["41838"] = 1, ["39447"] = 1, ["39669"] = 1, ["39884"] = 1, ["43030"] = 1, ["40398"] = 1, ["40161"] = 1, ["40510"] = 1, ["41049"] = 1, ["42072"] = 1, ["42073"] = 1, ["39877"] = 1, ["40221"] = 1, ["40366"] = 1, ["45462"] = 1, ["39875"] = 1, ["41531"] = 1, ["45460"] = 1, ["41495"] = 1, ["41494"] = 1, ["41455"] = 1, ["41731"] = 1, ["41633"] = 1, ["41801"] = 1, ["39881"] = 1, ["41640"] = 1, ["41802"] = 1, ["45514"] = 1, ["53870"] = 1, ["40601"] = 1, 

-- Verlorene Inseln
	["35769"] = 1, ["36470"] = 1, ["36471"] = 1, ["38120"] = 1, ["35778"] = 1, ["36519"] = 1, ["38513"] = 1, ["35758"] = 1, ["36518"] = 1, ["38122"] = 1, 

-- Verwstete Lande / The Blasted Lands
	["42298"] = 1, ["41165"] = 1, ["41164"] = 1, ["41267"] = 1, ["41193"] = 1, 

-- Westfall / Westfall
	["42384"] = 1, ["42308"] = 1, ["42558"] = 1, ["42309"] = 1, ["42559"] = 1, ["42390"] = 1, ["117"] = 1, ["452"] = 1, ["54371"] = 1, ["504"] = 1, ["122"] = 1, ["590"] = 1, ["124"] = 1, ["54372"] = 1, ["6182"] = 1, ["234"] = 1, ["98"] = 1, ["123"] = 1, ["42391"] = 1, ["42386"] = 1,  ["42383"] = 1, ["42407"] = 1, ["42413"] = 1, ["42387"] = 1, ["1236"] = 1, ["42492"] = 1, ["42515"] = 1, ["42680"] = 1, ["42662"] = 1, ["235"] = 1, ["42385"] = 1, ["42635"] = 1, ["453"] = 1, ["47296"] = 1, ["42677"] = 1, ["42699"] = 1, ["42697"] = 1, ["42700"] = 1, ["42371"] = 1, ["42749"] = 1, ["42755"] = 1, ["42748"] = 1, ["42753"] = 1, 

-- Die Todesminen / The Deadmines
	["47162"] = 1, ["47297"] = 1, ["47296"] = 1, ["43778"] = 1, ["47626"] = 1, ["48421"] = 1, ["48439"] = 1, ["48280"] = 1, 

-- Der Flammenschlund / Ragefire Chasm
	["61412"] = 1, ["61788"] = 1, 

-- Westliche Pestlnder
	["11936"] = 1, ["11582"] = 1, ["45110"] = 1, ["44323"] = 1, ["44452"] = 1, ["44453"] = 1, ["45166"] = 1, ["45212"] = 1, ["44269"] = 1, ["44454"] = 1, ["1838"] = 1, ["44436"] = 1, ["44441"] = 1, ["45162"] = 1, ["44439"] = 1, ["45155"] = 1, ["45152"] = 1, ["45235"] = 1, ["44458"] = 1, 
 
-- Wald von Elwynn / Elwynn Forest
	["50047"] = 1, ["16864"] = 1, ["951"] = 1, ["42937"] = 1, ["3937"] = 1, ["514"] = 1, ["97"] = 1, ["197"] = 1, ["257"] = 1, ["38"] = 1, ["80"] = 1, ["844"] = 1, ["40"] = 1, ["327"] = 1, ["253"] = 1, ["475"] = 1, ["63014"] = 1, ["64330"] = 1, 

-- Wlder von Terrokar
	["18482"] = 1, ["18635"] = 1, ["18794"] = 1, ["18634"] = 1, ["19672"] = 1, ["18311"] = 1, ["18341"] = 1, ["18313"] = 1, ["19666"] = 1, ["19671"] = 1, ["18956"] = 1, ["18731"] = 1, ["18667"] = 1, ["19673"] = 1, ["18713"] = 1, ["21644"] = 1, ["23383"] = 1, ["23038"] = 1, ["22314"] = 1, ["22452"] = 1, ["18588"] = 1, ["21660"] = 1, ["22377"] = 1, ["22464"] = 1, ["21661"] = 1, ["22483"] = 1, ["22459"] = 1, ["21662"] = 1, ["18459"] = 1, ["18713"] = 1, ["22458"] = 1, ["18760"] = 1, ["21400"] = 1, ["1410"] = 1, ["18745"] = 1, ["18424"] = 1, ["21006"] = 1, ["23377"] = 1, ["51908"] = 1, ["18999"] = 1, ["23367"] = 1, ["19676"] = 1, ["18548"] = 1, ["5355"] = 1, ["23133"] = 1, ["18554"] = 1, ["21399"] = 1, ["18373"] = 1, ["16769"] = 1, ["23048"] = 1, ["23016"] = 1, ["21397"] = 1, ["23415"] = 1, ["18718"] = 1, ["23257"] = 1, 

-- Winterquell
	["10980"] = 1, ["10978"] = 1, ["11193"] = 1, ["7524"] = 1, 

-- Zangarmarschen / Zangarmarsh
	["22832"] = 1, ["18340"] = 1, ["18042"] = 1, ["18117"] = 1, ["21894"] = 1, ["17959"] = 1, ["18586"] = 1, ["17941"] = 1, ["17969"] = 1, ["17841"] = 1, 

-- Zul'Drak / Zul'Drak
	["30024"] = 1, ["30022"] = 1, ["30019"] = 1, ["30102"] = 1, ["30193"] = 1, ["30020"] = 1, ["28255"] = 1, ["28041"] = 1, ["29050"] = 1, ["28952"] = 1, ["28948"] = 1, ["28916"] = 1, ["28996"] = 1, ["29028"] = 1, ["29647"] = 1, ["28752"] = 1, ["28754"] = 1, ["28442"] = 1, ["23574"] = 1, ["28750"] = 1, ["28575"] = 1, ["23578"] = 1, ["23577"] = 1, ["23576"] = 1, ["28495"] = 1, ["28244"] = 1, ["30023"] = 1, ["28503"] = 1, ["28998"] = 1, ["28518"] = 1, ["28873"] = 1, ["28415"] = 1, ["28479"] = 1, ["28175"] = 1, ["28177"] = 1, ["28176"] = 1, ["28068"] = 1, ["29686"] = 1, ["28805"] = 1, ["28480"] = 1, ["28178"] = 1, ["29437"] = 1, ["29450"] = 1, ["29449"] = 1, ["29890"] = 1, ["28532"] = 1, ["28541"] = 1, ["28801"] = 1, ["29451"] = 1, ["29892"] = 1, ["30007"] = 1, ["30017"] = 1, ["30021"] = 1, ["30098"] = 1, ["29654"] = 1, 

-- Der Jadewald / The Jade Forrest
	["66473"] = 1, ["67069"] = 1, ["66963"] = 1, ["66292"] = 1, ["66583"] = 1, ["54914"] = 1, ["59058"] = 1, ["59348"] = 1, ["56398"] = 1, ["54894"] = 1, ["55335"] = 1, ["55337"] = 1, ["55338"] = 1, ["55343"] = 1, ["55283"] = 1, ["55353"] = 1, ["55373"] = 1, ["55374"] = 1, ["55381"] = 1, ["55611"] = 1, ["55406"] = 1, ["55407"] = 1, ["56592"] = 1, ["56690"] = 1, ["56585"] = 1, ["56592"] = 1, ["54959"] = 1, ["56591"] = 1, ["56701"] = 1, ["56672"] = 1, ["54615"] = 1, ["66282"] = 1, ["67012"] = 1, ["66300"] = 1, ["66501"] = 1, ["66666"] = 1, ["64596"] = 1, ["66296"] = 1, ["66574"] = 1, ["66575"] = 1, ["66209"] = 1, ["61402"] = 1, ["66295"] = 1, ["66274"] = 1, ["66366"] = 1, ["66272"] = 1, ["66271"] = 1, ["66270"] = 1, ["66275"] = 1, ["66581"] = 1, ["67067"] = 1, ["66034"] = 1, ["57119"] = 1, ["55196"] = 1, ["55490"] = 1, ["55201"] = 1, ["56448"] = 1, ["56843"] = 1, ["59546"] = 1, ["58826"] = 1, ["62171"] = 1, ["56439"] = 1, ["56693"] = 1, ["66949"] = 1, ["59704"] = 1, ["59822"] = 1, ["56637"] = 1, ["56849"] = 1, ["56717"] = 1, ["59519"] = 1, ["59074"] = 1, ["59479"] = 1, ["64361"] = 1, ["66379"] = 1, ["61218"] = 1, ["64492"] = 1, ["56674"] = 1, ["56673"] = 1, ["56670"] = 1, ["56671"] = 1, ["56726"] = 1, ["56727"] = 1, ["56728"] = 1, ["56725"] = 1, ["54868"] = 1, ["55461"] = 1, ["54960"] = 1, ["56461"] = 1, ["56463"] = 1, ["56442"] = 1, ["56444"] = 1, ["56488"] = 1, ["60970"] = 1, ["55234"] = 1, ["63609"] = 1, ["63601"] = 1, ["56707"] = 1, ["56062"] = 1, ["56705"] = 1, ["56348"] = 1, ["56771"] = 1, ["55368"] = 1, ["55267"] = 1, ["54697"] = 1, ["54854"] = 1, ["54763"] = 1, ["54702"] = 1, ["55081"] = 1, ["55209"] = 1, ["54989"] = 1, ["54990"] = 1, ["55016"] = 1, ["56063"] = 1, ["56209"] = 1, ["56210"] = 1, ["56206"] = 1, ["59257"] = 1, ["59255"] = 1, ["59256"] = 1, ["59254"] = 1, ["56345"] = 1, ["56346"] = 1, ["56347"] = 1, ["56464"] = 1, ["56510"] = 1, ["61671"] = 1, ["55279"] = 1, ["56467"] = 1, ["55614"] = 1, ["55291"] = 1, ["55290"] = 1, ["56116"] = 1, ["56596"] = 1, ["55028"] = 1, ["54918"] = 1, ["54917"] = 1, ["54922"] = 1, ["54915"] = 1, ["54944"] = 1, ["54924"] = 1, ["54925"] = 1, ["54926"] = 1, ["55092"] = 1, ["54987"] = 1, ["59392"] = 1, ["59397"] = 1, ["59401"] = 1, ["59395"] = 1, ["56784"] = 1, ["56787"] = 1, ["56779"] = 1, ["59572"] = 1, ["59609"] = 1, ["59562"] = 1, ["59562"] = 1, ["65900"] = 1, ["66406"] = 1, ["54617"] = 1, ["66441"] = 1, ["65910"] = 1, ["61492"] = 1, ["66978"] = 1, ["54616"] = 1, ["66396"] = 1, ["66269"] = 1, ["66321"] = 1, ["66267"] = 1, ["56310"] = 1, ["65911"] = 1, ["55299"] = 1, ["56732"] = 1, ["64333"] = 1, ["64331"] = 1, ["54980"] = 1, ["55560"] = 1, ["59554"] = 1, ["55084"] = 1, ["64315"] = 1, ["59173"] = 1, ["59253"] = 1, ["56474"] = 1, ["57936"] = 1, ["56573"] = 1, ["58785"] = 1, ["56614"] = 1, ["57708"] = 1, ["57275"] = 1, ["58027"] = 1, ["57952"] = 1, ["58341"] = 1, ["60021"] = 1, ["65843"] = 1, ["66896"] = 1, ["66897"] = 1, ["39622"] = 1, ["44293"] = 1, ["56434"] = 1, ["56562"] = 1, ["58609"] = 1, ["59608"] = 1, ["59189"] = 1, ["64848"] = 1, ["64540"] = 1, ["66975"] = 1, ["56839"] = 1, ["56485"] = 1, ["59188"] = 1, ["54614"] = 1, ["66370"] = 1, ["56365"] = 1, ["55819"] = 1, ["56629"] = 1, ["59450"] = 1, ["59069"] = 1, ["66407"] = 1, ["59068"] = 1, ["66603"] = 1, ["56364"] = 1, ["55789"] = 1, ["55333"] = 1, ["55355"] = 1, ["57389"] = 1, ["58225"] = 1, ["58228"] = 1, ["58564"] = 1, ["58506"] = 1, ["61406"] = 1, ["66277"] = 1, ["66276"] = 1, ["65912"] = 1, ["55193"] = 1, ["61557"] = 1, ["55788"] = 1, ["59178"] = 1, ["59179"] = 1, ["55486"] = 1, ["54703"] = 1, ["56349"] = 1, ["65635"] = 1, ["59070"] = 1, ["66369"] = 1, ["56785"] = 1, ["66273"] = 1, ["59160"] = 1, ["63742"] = 1, ["66351"] = 1, ["66350"] = 1, ["65907"] = 1, 
	
-- Admiralin Rogers, 

-- Krasarang Wildnis / Krasarang Wilds
	["58639"] = 1, ["58630"] = 1, ["10980"] = 1, ["58955"] = 1, ["58745"] = 1, ["58224"] = 1, ["58821"] = 1, ["59021"] = 1, ["60491"] = 1, ["63754"] = 1, ["63542"] = 1, ["59483"] = 1, ["59577"] = 1, ["59645"] = 1, ["65928"] = 1, ["63754"] = 1, ["65843"] = 1, ["58735"] = 1, ["56114"] = 1, ["58814"] = 1, ["58117"] = 1, ["58165"] = 1, ["58068"] = 1, ["58926"] = 1, ["58158"] = 1, ["58273"] = 1, ["58634"] = 1, ["60290"] = 1, ["60289"] = 1, ["60293"] = 1, ["60139"] = 1, ["57457"] = 1, ["57830"] = 1, ["57825"] = 1, ["57310"] = 1, ["57898"] = 1, ["56115"] = 1, ["58379"] = 1, ["58410"] = 1, ["58978"] = 1, ["59098"] = 1, ["59189"] = 1, ["59138"] = 1, ["58969"] = 1, ["58968"] = 1, ["59653"] = 1, ["59584"] = 1, ["62232"] = 1, ["63328"] = 1, ["58113"] = 1, ["64542"] = 1, ["64566"] = 1, ["64853"] = 1, ["58666"] = 1, ["58607"] = 1, ["59851"] = 1, ["50768"] = 1, ["63721"] = 1, ["58606"] = 1, ["65638"] = 1, ["58377"] = 1, ["65626"] = 1, ["68519"] = 1, ["68514"] = 1, ["68515"] = 1, ["68516"] = 1, ["68517"] = 1, ["68518"] = 1, ["68331"] = 1, ["68399"] = 1, ["68312"] = 1, ["68944"] = 1, ["68930"] = 1, ["68945"] = 1, ["67976"] = 1, ["67386"] = 1, ["67435"] = 1, ["68599"] = 1, ["67883"] = 1, ["68474"] = 1, ["69026"] = 1, ["68842"] = 1, ["67761"] = 1, ["58970"] = 1, ["58975"] = 1, ["58894"] = 1, ["63885"] = 1, ["50816"] = 1, 
-- Ultra-Pengsplodierer 2500
		
-- Die verhllte Treppe / The Ancient Passage
	["61761"] = 1, ["63494"] = 1, ["64616"] = 1, ["62928"] = 1, 
-- Furorion, 

-- Tal der vier Winde / Valley of the four Winds
	["57183"] = 1, ["57161"] = 1, ["57123"] = 1, ["57126"] = 1, ["57121"] = 1, ["57122"] = 1, ["57120"] = 1, ["57199"] = 1, ["56714"] = 1, ["56827"] = 1, ["56138"] = 1, ["56133"] = 1, ["56184"] = 1, ["64451"] = 1, ["58716"] = 1, ["56204"] = 1, ["57716"] = 1, ["57713"] = 1, ["57714"] = 1, ["57715"] = 1, ["56207"] = 1, ["55873"] = 1, ["56465"] = 1, ["56462"] = 1, ["56440"] = 1, ["56185"] = 1, ["56205"] = 1, ["56208"] = 1, ["65870"] = 1, ["65874"] = 1, ["58736"] = 1, ["65871"] = 1, ["56729"] = 1, ["56802"] = 1, ["64231"] = 1, ["59585"] = 1, ["64448"] = 1, ["57405"] = 1, ["62346"] = 1, ["57648"] = 1, ["58723"] = 1, ["58729"] = 1, ["58734"] = 1, ["58733"] = 1, ["58718"] = 1, ["58706"] = 1, ["56720"] = 1, ["63822"] = 1, ["58422"] = 1, ["58955"] = 1, ["58477"] = 1, ["58462"] = 1, ["56312"] = 1, ["56338"] = 1, ["56573"] = 1, ["56537"] = 1, ["56538"] = 1, ["56549"] = 1, ["57204"] = 1, ["56680"] = 1, ["56691"] = 1, ["62377"] = 1, ["62385"] = 1, ["57401"] = 1, ["57415"] = 1, ["66326"] = 1, ["59647"] = 1, ["57413"] = 1, ["66264"] = 1, ["57432"] = 1, ["57423"] = 1, ["57213"] = 1, ["57628"] = 1, ["57662"] = 1, ["58014"] = 1, ["58015"] = 1, ["59320"] = 1, ["58421"] = 1, ["56337"] = 1, ["57681"] = 1, ["56723"] = 1, ["59844"] = 1, ["59829"] = 1, ["59887"] = 1, ["59841"] = 1, ["59843"] = 1, ["59840"] = 1, ["59839"] = 1, ["59889"] = 1, ["59890"] = 1, ["59888"] = 1, ["59856"] = 1, ["66655"] = 1, ["56520"] = 1, ["59580"] = 1, ["59797"] = 1, ["57406"] = 1, ["63934"] = 1, ["65817"] = 1, ["65796"] = 1, ["65804"] = 1, ["65795"] = 1, ["64200"] = 1, ["64193"] = 1, ["63939"] = 1, ["59183"] = 1, ["65818"] = 1, ["65810"] = 1, ["59224"] = 1, ["57963"] = 1, ["56110"] = 1, ["59514"] = 1, 
	["59513"] = 1, ["57385"] = 1, 
-- Furchtschrer der Ik'thi

-- Kun-Lai Gipfel / Kun-Lai Summit
	["59055"] = 1, ["59073"] = 1, ["59019"] = 1, ["59077"] = 1, ["58961"] = 1, ["59076"] = 1, ["59143"] = 1, ["59441"] = 1, ["59441"] = 1, ["59758"] = 1, ["60038"] = 1, ["59968"] = 1, ["59972"] = 1, ["60127"] = 1, ["63820"] = 1, ["61566"] = 1, ["59166"] = 1, ["60973"] = 1, ["61582"] = 1, ["61649"] = 1, ["61069"] = 1, ["61572"] = 1, ["61621"] = 1, ["59263"] = 1, ["61693"] = 1, ["59335"] = 1, ["59371"] = 1, ["59826"] = 1, ["59402"] = 1, ["59578"] = 1, ["61504"] = 1, ["59701"] = 1, ["62158"] = 1, ["60508"] = 1, ["61850"] = 1, ["59688"] = 1, ["59695"] = 1, ["62821"] = 1, ["62822"] = 1, ["59805"] = 1, ["59802"] = 1, ["59703"] = 1, ["59877"] = 1, ["60955"] = 1, ["60023"] = 1, ["60769"] = 1, ["61305"] = 1, ["61641"] = 1, ["60572"] = 1, ["60769"] = 1, ["60524"] = 1, ["60161"] = 1, ["60161"] = 1, ["61303"] = 1, ["61525"] = 1, ["60236"] = 1, ["60187"] = 1, ["60229"] = 1, ["60190"] = 1, ["60235"] = 1, ["60189"] = 1, ["60234"] = 1, ["60416"] = 1, ["60503"] = 1, ["61454"] = 1, ["61820"] = 1, ["61454"] = 1, ["61819"] = 1, ["62220"] = 1, ["59751"] = 1, ["62220"] = 1, ["59083"] = 1, ["59180"] = 1, ["60995"] = 1, ["59165"] = 1, ["59442"] = 1, ["59486"] = 1, ["59821"] = 1, ["59353"] = 1, ["61490"] = 1, ["59790"] = 1, ["61489"] = 1, ["61488"] = 1, ["59592"] = 1, ["62149"] = 1, ["59527"] = 1, ["59556"] = 1, ["59876"] = 1, ["59452"] = 1, ["59424"] = 1, ["59958"] = 1, ["60012"] = 1, ["59495"] = 1, ["59894"] = 1, ["60090"] = 1, ["59421"] = 1, ["60015"] = 1, ["59419"] = 1, ["60598"] = 1, ["60188"] = 1, ["60679"] = 1, ["60587"] = 1, ["60749"] = 1, ["61252"] = 1, ["61571"] = 1, ["61297"] = 1, ["63505"] = 1, ["62971"] = 1, ["64545"] = 1, ["61534"] = 1, ["66261"] = 1, ["61381"] = 1, ["66165"] = 1, ["61417"] = 1, ["64202"] = 1, ["66700"] = 1, ["61545"] = 1, ["63602"] = 1, ["63757"] = 1, ["62629"] = 1, ["61541"] = 1, ["65897"] = 1, ["65896"] = 1, ["60694"] = 1, ["60785"] = 1, ["64542"] = 1, ["64540"] = 1, ["64528"] = 1, ["64537"] = 1, ["64536"] = 1, ["61118"] = 1, ["60767"] = 1, ["62707"] = 1, ["59181"] = 1, ["59827"] = 1, ["60596"] = 1, ["59412"] = 1, ["60008"] = 1, ["64276"] = 1, ["61503"] = 1, ["63499"] = 1, ["62366"] = 1, ["56762"] = 1, ["57286"] = 1, ["59901"] = 1, ["61523"] = 1, ["60119"] = 1, ["60599"] = 1, ["62970"] = 1, ["61496"] = 1, ["60580"] = 1, ["66693"] = 1, ["64631"] = 1, ["66101"] = 1, ["61130"] = 1, ["61012"] = 1, ["59451"] = 1, 

-- Tonlongsteppe / Tonlong Steppes
	["60684"] = 1, ["60688"] = 1, ["60689"] = 1, ["60763"] = 1, ["60730"] = 1, ["60801"] = 1, ["55339"] = 1, ["60735"] = 1, ["60683"] = 1, ["60764"] = 1, ["60734"] = 1, ["60802"] = 1, ["60822"] = 1, ["60951"] = 1, ["61015"] = 1, ["61050"] = 1, ["61138"] = 1, ["61006"] = 1, ["61067"] = 1, ["61524"] = 1, ["61396"] = 1, ["61527"] = 1, ["61397"] = 1, ["61818"] = 1, ["62444"] = 1, ["62410"] = 1, ["62400"] = 1, ["62124"] = 1, ["62436"] = 1, ["62735"] = 1, ["62736"] = 1, ["61020"] = 1, ["62788"] = 1, ["62280"] = 1, ["65714"] = 1, ["62730"] = 1, ["62580"] = 1, ["62581"] = 1, ["62579"] = 1, ["62593"] = 1, ["65586"] = 1, ["62541"] = 1, ["61390"] = 1, ["64474"] = 1, ["61209"] = 1, ["61208"] = 1, ["61210"] = 1, ["61207"] = 1, ["64474"] = 1, ["60881"] = 1, ["61563"] = 1, ["61881"] = 1, ["61880"] = 1, ["61055"] = 1, ["62278"] = 1, ["61161"] = 1, ["61683"] = 1, ["61695"] = 1, ["61585"] = 1, ["61162"] = 1, ["61616"] = 1, ["61580"] = 1, ["60880"] = 1, ["62595"] = 1, ["64240"] = 1, ["64239"] = 1, ["64237"] = 1, ["64236"] = 1, ["64241"] = 1, ["64238"] = 1, ["70360"] = 1, ["70482"] = 1, ["70370"] = 1, ["69674"] = 1, ["70517"] = 1, ["69673"] = 1, ["69379"] = 1, ["69254"] = 1, ["69241"] = 1, ["69678"] = 1, ["69694"] = 1, ["69228"] = 1, ["69686"] = 1, ["69692"] = 1, ["69682"] = 1, ["69684"] = 1, ["69691"] = 1, ["69227"] = 1, ["60687"] = 1, ["61066"] = 1, ["62802"] = 1, ["61469"] = 1, ["60687"] = 1, ["63617"] = 1, ["61468"] = 1, 

-- Schreckensde / Dread Wastes
	["62538"] = 1, ["65327"] = 1, ["62202"] = 1, ["62519"] = 1, ["62774"] = 1, ["62863"] = 1, ["65478"] = 1, ["63876"] = 1, ["64013"] = 1, ["62542"] = 1, ["64485"] = 1, ["63998"] = 1, ["63349"] = 1, ["63280"] = 1, ["63317"] = 1, ["64259"] = 1, ["64379"] = 1, ["64378"] = 1, ["63043"] = 1, ["62668"] = 1, ["62666"] = 1, ["67138"] = 1, ["63359"] = 1, ["64366"] = 1, ["63071"] = 1, ["67091"] = 1, ["58646"] = 1, ["60002"] = 1, ["59921"] = 1, ["58465"] = 1, ["60067"] = 1, ["59450"] = 1, ["65422"] = 1, ["62690"] = 1, ["62752"] = 1, ["64344"] = 1, ["63786"] = 1, ["62540"] = 1, ["62352"] = 1, ["62166"] = 1, ["62518"] = 1, ["65365"] = 1, ["62180"] = 1, ["62960"] = 1, ["63055"] = 1, ["63118"] = 1, ["62778"] = 1, ["63103"] = 1, ["63102"] = 1, ["63104"] = 1, ["62773"] = 1, ["62667"] = 1, ["66497"] = 1, 

-- Tal der ewigen Blten / Vale of eternal Blossoms
	["63367"] = 1, ["63490"] = 1, ["63495"] = 1, ["64012"] = 1, ["64482"] = 1, ["64092"] = 1, ["65576"] = 1, ["64149"] = 1, ["65578"] = 1, ["64078"] = 1, ["65577"] = 1, ["59925"] = 1, ["62301"] = 1, ["62203"] = 1, ["62202"] = 1, ["62413"] = 1, ["59908"] = 1, ["59961"] = 1, ["64029"] = 1, ["58468"] = 1, ["50749"] = 1, ["64153"] = 1, ["64164"] = 1, ["63013"] = 1, ["65252"] = 1, ["63041"] = 1, ["61962"] = 1, ["59905"] = 1, 

-- Shado-Pan Kloster / Shado-pan Monastery
	["56747"] = 1, ["65407"] = 1, ["56870"] = 1, ["56541"] = 1, ["56719"] = 1, ["56884"] = 1, ["63717"] = 1, ["58198"] = 1, 

-- Scenarien / Scenarios
	["62467"] = 1, ["62495"] = 1, ["62488"] = 1, ["62465"] = 1, ["64901"] = 1, ["62783"] = 1, ["62793"] = 1, ["63811"] = 1, ["64189"] = 1, ["64089"] = 1, ["63817"] = 1, ["65316"] = 1, ["61814"] = 1, ["61766"] = 1, ["62009"] = 1, ["61707"] = 1, ["62787"] = 1, 

-- Das Tor der untergehenden Sonne / Gate of the setting sun
	["56906"] = 1, ["58146"] = 1, ["56745"] = 1, ["56589"] = 1, ["56636"] = 1, ["66905"] = 1, ["56905"] = 1, ["56877"] = 1, ["64467"] = 1, ["54467"] = 1, 

-- scharlachrote Hallen / Scarlet halls
	["59191"] = 1, ["59303"] = 1, ["59302"] = 1, ["58632"] = 1, 

-- Scholomance / Scholomance
	["58633"] = 1, ["64563"] = 1, ["59184"] = 1, ["58875"] = 1, ["59200"] = 1, ["58722"] = 1, ["59613"] = 1, ["59080"] = 1, ["64562"] = 1, ["59368"] = 1, ["64683"] = 1, ["64660"] = 1, 

-- Die Belagerung des Niuzaotempels / Siege of Niuazo Temple
	["61485"] = 1, ["62205"] = 1, ["61567"] = 1, ["61620"] = 1, 

-- Mogu'shan Palast / Mogu'shan Palace
	["61884"] = 1, ["61445"] = 1, ["61453"] = 1, ["61444"] = 1, ["61447"] = 1, ["61442"] = 1, ["61243"] = 1, 

-- Burg Schattenfang / Shadowfang Keep
	["47006"] = 1, ["46962"] = 1, ["47027"] = 1, ["3887"] = 1, ["3873"] = 1, ["3877"] = 1, ["4278"] = 1, ["46963"] = 1, ["46964"] = 1, 

-- Violette Festung / The Violet Hold
	["30893"] = 1, ["30668"] = 1, ["30661"] = 1, ["30659"] = 1, ["29315"] = 1, ["29266"] = 1, ["29314"] = 1, ["29316"] = 1, ["29312"] = 1, ["30660"] = 1, ["30892"] = 1, ["31134"] = 1, ["30666"] = 1, ["29313"] = 1, 

-- Burg Utgarde / Utgarde Keep
	["24068"] = 1, ["24069"] = 1, ["24080"] = 1, ["23956"] = 1, ["23961"] = 1, 

-- Nexus / Nexus
	["27631"] = 1, 

-- Gipfel der Ruhe / Peak of Serenity
	["66260"] = 1, ["66844"] = 1, ["64975"] = 1, ["66253"] = 1, ["66254"] = 1, ["66257"] = 1, ["66207"] = 1, ["66258"] = 1, ["66073"] = 1, 

-- Das Verlies / The Stockade
	["46379"] = 1, ["46381"] = 1, ["46383"] = 1, ["46482"] = 1, ["46264"] = 1, ["46254"] = 1, 

-- Durnhold / Old Hillsbrad Foothills
	["18598"] = 1, ["17876"] = 1, ["18764"] = 1, ["18934"] = 1, ["18723"] = 1, ["18094"] = 1, ["17848"] = 1, ["23177"] = 1, ["17862"] = 1, ["18887"] = 1, ["18096"] = 1, ["17833"] = 1, ["18725"] = 1, ["17820"] = 1, ["17821"] = 1, ["17819"] = 1, ["51359"] = 1, ["23175"] = 1, ["23176"] = 1, ["28132"] = 1, ["28126"] = 1, ["18656"] = 1, ["17860"] = 1, ["23178"] = 1, ["18093"] = 1, ["18672"] = 1, ["18655"] = 1, ["18172"] = 1, 

-- Azjol-Nerub / Azjol-Nerub
	["28684"] = 1, ["28922"] = 1, ["29120"] = 1, 

-- Managruft / Mana-Tombs
	["18309"] = 1, ["54692"] = 1, ["54694"] = 1, ["18344"] = 1, 

-- Gnomeregan / Gnomeregan
	["7998"] = 1, ["7849"] = 1, ["6235"] = 1, ["7800"] = 1, 

-- Das scharlachrote Kloster / Scarlet Monastery
	["59789"] = 1, ["59223"] = 1, ["60040"] = 1, ["58569"] = 1, ["3977"] = 1, ["64841"] = 1, ["58676"] = 1, ["59372"] = 1, ["59150"] = 1, ["58783"] = 1, ["64842"] = 1, ["58605"] = 1, ["58898"] = 1, ["58685"] = 1, ["58684"] = 1, ["58563"] = 1, ["64764"] = 1, ["58555"] = 1, ["58590"] = 1, 

-- Uldaman / Uldaman
	["7228"] = 1, ["7291"] = 1, ["4854"] = 1, ["2748"] = 1, ["7172"] = 1, 

-- Dsterbruch / 
	["14354"] = 1, ["11491"] = 1, ["11489"] = 1, ["11496"] = 1, ["11466"] = 1, ["11486"] = 1, 

-- Stratholm / Stratholme
	["11058"] = 1, ["10411"] = 1, ["11142"] = 1, ["10424"] = 1, ["10422"] = 1, ["10808"] = 1, ["10399"] = 1, ["10436"] = 1, ["10439"] = 1, ["10394"] = 1, ["45412"] = 1, ["45329"] = 1, ["10435"] = 1, ["26530"] = 1, ["26499"] = 1, ["28340"] = 1, ["28341"] = 1, ["26532"] = 1, ["26533"] = 1, 

-- Tiefensumpf / The Underbog
	["17826"] = 1, ["54678"] = 1, ["17735"] = 1, ["17940"] = 1, ["21127"] = 1, ["17960"] = 1,  

-- Sethekkhallen / Sethekk Halls
	["18472"] = 1, ["18473"] = 1, 

-- Zul'Farrak / Zul'Farrak
	["8127"] = 1, ["7274"] = 1, ["7797"] = 1, ["7267"] = 1, 

-- Schwarzfels / Blackrock
	["9017"] = 1, ["9537"] = 1, ["9547"] = 1, ["9156"] = 1, ["9938"] = 1, ["9019"] = 1, ["8929"] = 1, ["9026"] = 1,  ["8891"] = 1, ["9039"] = 1, ["8983"] = 1, ["9543"] = 1, ["9502"] = 1, ["8905"] = 1, ["45888"] = 1, ["10043"] = 1, ["10096"] = 1, 

-- Naxxramas
	["15956"] = 1, ["15953"] = 1, ["16028"] = 1, ["19928"] = 1, ["16061"] = 1, ["16060"] = 1, ["15954"] = 1, ["16011"] = 1, ["159906"] = 1, 

-- Mnch Startgebiet (Die wandernde Insel) / Monk startarea (Wandering Isle)
	["53565"] = 1, ["54587"] = 1, ["53566"] = 1, ["53565"] = 1, ["54611"] = 1, ["54943"] = 1, ["56503"] = 1, ["54130"] = 1, ["54567"] = 1, ["59652"] = 1, ["54856"] = 1, ["54568"] = 1, ["60176"] = 1, ["54135"] = 1, ["60253"] = 1, ["60248"] = 1, ["60245"] = 1, ["54786"] = 1, ["61126"] = 1, ["61127"] = 1, ["60250"] = 1, ["60249"] = 1, ["57638"] = 1, ["65493"] = 1, ["57712"] = 1, ["55483"] = 1, ["57669"] = 1, ["55694"] = 1, ["64885"] = 1, ["55744"] = 1, ["56661"] = 1, ["57769"] = 1, ["56676"] = 1, ["59986"] = 1, ["60042"] = 1, ["55943"] = 1, ["56236"] = 1, ["55944"] = 1, ["56416"] = 1, ["60729"] = 1, ["60770"] = 1, ["60878"] = 1, ["60851"] = 1, ["60888"] = 1, ["60889"] = 1, ["61792"] = 1, 

-- Sonstige 1
	["40788"] = 1, ["40825"] = 1, ["39679"] = 1, ["36296"] = 1, ["36565"] = 1, ["36272"] = 1, ["38066"] = 1, ["47324"] = 1, ["47325"] = 1, ["39731"] = 1, ["39428"] = 1, ["39732"] = 1, ["39587"] = 1, ["39378"] = 1, ["30899"] = 1, ["30898"] = 1, ["30897"] = 1, ["27978"] = 1, ["27977"] = 1, ["27975"] = 1, ["32639"] = 1, ["32638"] = 1, ["26401"] = 1, ["26216"] = 1, ["25949"] = 1, ["25951"] = 1, ["25324"] = 1, ["34386"] = 1, ["34489"] = 1, ["15491"] = 1, ["24710"] = 1, ["23684"] = 1, ["23683"] = 1, ["23685"] = 1, ["23872"] = 1, ["23795"] = 1, ["34520"] = 1, ["33532"] = 1, ["34519"] = 1, ["33533"] = 1, ["34365"] = 1, ["22818"] = 1, ["14305"] = 1, ["34387"] = 1, ["19173"] = 1, ["19148"] = 1, ["19172"] = 1, ["39623"] = 1, ["39253"] = 1, ["18927"] = 1, ["23758"] = 1, ["23686"] = 1, ["23682"] = 1, ["23775"] = 1, ["40765"] = 1, ["39665"] = 1, ["39670"] = 1, ["39698"] = 1, ["39705"] = 1, ["40586"] = 1, ["40792"] = 1, ["43875"] = 1, ["39959"] = 1, ["43878"] = 1, ["43047"] = 1, ["34721"] = 1, ["34723"] = 1, ["34715"] = 1, ["23712"] = 1, ["23543"] = 1, ["61348"] = 1, ["68685"] = 1, ["68851"] = 1, ["59369"] = 1, ["62508"] = 1, ["63256"] = 1, ["24833"] = 1, ["65785"] = 1, ["65442"] = 1, ["8506"] = 1, ["9499"] = 1, ["8911"] = 1, ["3673"] = 1, ["3670"] = 1, ["3678"] = 1, ["3679"] = 1, ["5721"] = 1, ["8440"] = 1,["94"] = 1,  

-- Sonstige 2
	["5710"] = 1, ["5709"] = 1, ["61242"] = 1, ["61398"] = 1, ["61551"] = 1, ["59158"] = 1, ["59075"] = 1, ["24484"] = 1, ["23710"] = 1, ["23709"] = 1, ["24536"] = 1, ["23698"] = 1, ["56872"] = 1, ["36024"] = 1, ["54336"] = 1, ["27169"] = 1, ["51666"] = 1, ["66362"] = 1, ["15745"] = 1, ["15746"] = 1, ["54476"] = 1, ["39997"] = 1, ["65154"] = 1, ["64900"] = 1, ["64727"] = 1, ["63315"] = 1, ["38995"] = 1, ["38579"] = 1, ["61140"] = 1, ["60143"] = 1, ["48253"] = 1, ["51165"] = 1, ["62980"] = 1, ["62543"] = 1, ["63191"] = 1, ["50354"] = 1, ["50332"] = 1, ["50772"] = 1, ["16781"] = 1, ["60709"] = 1, ["60710"] = 1, ["60701"] = 1, ["60708"] = 1, ["64068"] = 1, ["62397"] = 1, ["62511"] = 1, ["62837"] = 1, ["62983"] = 1, ["60999"] = 1, ["60410"] = 1, ["60648"] = 1, ["63818"] = 1, ["68057"] = 1, ["67569"] = 1, ["58740"] = 1, ["68871"] = 1, ["61634"] = 1, ["60583"] = 1, ["60586"] = 1, ["60585"] = 1, ["65501"] = 1, ["44577"] = 1, ["49045"] = 1, ["43612"] = 1, ["44819"] = 1, ["58756"] = 1, ["58664"] = 1, ["63025"] = 1, ["62442"] = 1, ["37715"] = 1, ["67671"] = 1, ["67870"] = 1, ["38334"] = 1, ["38335"] = 1, ["38336"] = 1, ["38337"] = 1, ["38338"] = 1, ["38339"] = 1, ["43929"] = 1, ["6927"] = 1, ["69134"] = 1, ["16424"] = 1, ["60149"] = 1, ["60009"] = 1, ["28043"] = 1, ["28056"] = 1, ["28136"] = 1, ["28090"] = 1, 


-- Sonstige 3
	["69223"] = 1, ["69281"] = 1, ["69444"] = 1, ["69250"] = 1, ["61434"] = 1, ["69698"] = 1, ["69305"] = 1, ["69267"] = 1, ["69236"] = 1, ["67992"] = 1, ["69600"] = 1, ["69538"] = 1, ["69226"] = 1, ["33896"] = 1, ["52530"] = 1, ["53494"] = 1, ["53619"] = 1, ["52571"] = 1, ["52409"] = 1, ["53876"] = 1, ["53872"] = 1, ["53875"] = 1, ["69078"] = 1, ["69132"] = 1, ["69131"] = 1, ["59538"] = 1, ["49869"] = 1, ["49874"] = 1, ["67414"] = 1, ["67266"] = 1, ["68323"] = 1, ["68377"] = 1, ["68405"] = 1, ["68408"] = 1, ["67524"] = 1, ["17517"] = 1, ["67451"] = 1, ["67596"] = 1, ["68252"] = 1, ["67591"] = 1, ["67511"] = 1, ["67514"] = 1, ["67516"] = 1, ["67513"] = 1, ["17491"] = 1, ["17371"] = 1, ["17726"] = 1, ["17938"] = 1, ["69755"] = 1, ["70348"] = 1, ["69229"] = 1, ["70347"] = 1, ["65648"] = 1, ["65651"] = 1, ["65655"] = 1, ["61756"] = 1, ["69465"] = 1, ["68476"] = 1, ["48230"] = 1, ["63194"] = 1, ["65656"] = 1, ["66515"] = 1, ["66520"] = 1, ["66478"] = 1, ["66512"] = 1, ["66522"] = 1, ["28310"] = 1, ["27842"] = 1, ["70235"] = 1, ["70247"] = 1, ["69712"] = 1, ["67977"] = 1, 	["28284"] = 1, ["28192"] = 1, ["27987"] = 1, ["68036"] = 1, ["69017"] = 1, ["69702"] = 1, ["69427"] = 1, ["69099"] = 1, ["69559"] = 1, ["69923"] = 1, ["69482"] = 1, ["69483"] = 1, ["69530"] = 1, ["69501"] = 1, ["69617"] = 1, ["69620"] = 1, ["69619"] = 1, ["69065"] = 1, ["69435"] = 1, ["69461"] = 1, ["69326"] = 1, ["68397"] = 1, ["30695"] = 1, ["29281"] = 1, 
		
-- Sonstige 4
	["26687"] = 1, ["26693"] = 1, ["26861"] = 1, ["26668"] = 1, ["27885"] = 1, ["27884"] = 1, ["27891"] = 1, ["27745"] = 1, ["26528"] = 1, ["26497"] = 1, ["28167"] = 1, ["35005"] = 1, ["34995"] = 1, ["34994"] = 1, ["34996"] = 1, ["34990"] = 1, ["34992"] = 1, ["34991"] = 1, ["34928"] = 1, ["35451"] = 1, ["41498"] = 1, ["40489"] = 1, ["43898"] = 1, ["43036"] = 1, ["42574"] = 1, ["42573"] = 1, ["42885"] = 1, ["44879"] = 1, ["44936"] = 1, ["39751"] = 1, ["39747"] = 1, ["39746"] = 1, ["39863"] = 1, ["39748"] = 1, ["39750"] = 1, ["59532"] = 1, ["59516"] = 1, ["65598"] = 1, ["58257"] = 1, ["45043"] = 1, ["43996"] = 1, ["50363"] = 1, ["50730"] = 1, ["62878"] = 1, ["65160"] = 1, ["69225"] = 1, ["69256"] = 1, ["69338"] = 1, ["69210"] = 1, ["69666"] = 1, ["69696"] = 1, ["65869"] = 1, ["58464"] = 1, ["51078"] = 1, ["58717"] = 1, ["57402"] = 1, ["57298"] = 1, ["58705"] = 1, ["58707"] = 1, ["37119"] = 1, ["50831"] = 1, ["50817"] = 1, ["58761"] = 1, ["50338"] = 1, ["50766"] = 1, ["50828"] = 1, ["50776"] = 1, ["58647"] = 1, ["58712"] = 1,  

	}


  local tip = CreateFrame("GameTooltip")
  tip.txt = tip:CreateFontString()
  tip:AddFontStrings(tip.txt, tip:CreateFontString())

  local function ScanNPCName(npcID)
    	tip:SetOwner(WorldFrame, "ANCHOR_NONE")
    	tip:SetHyperlink(("unit:0xF53%05X00000000"):format(npcID))
    	return tip:IsShown() and tip.txt:GetText()
  end

  local ignoreNPC = {}
  local rescanNPC = {}

  local function ScanNPCs(tbl)
    	for npcID, _ in pairs(tbl) do
      	local npcName = ScanNPCName(npcID)
      		if npcName then
        			ignoreNPC[npcName] = 1
        			rescanNPC[npcID] = nil -- since it now exists we remove it from the "to-rescanNPC-later" list
      		else
        			rescanNPC[npcID] = 1 -- not cached yet so we add the id to the "to-rescanNPC-later" list
      		end
    	end
  end

  ScanNPCs(database)

  local function ChatFilter(self, event, message, sender, ...)
--    print(NPCSilencerData.Enabled and "ENABLED" or "DISABLED")
	if NPCSilencerData.Enabled then
      	ScanNPCs(rescanNPC) -- we scan leftovers on ChatFilter triggers
      	return ignoreNPC[sender] and true or false
    	end
    		return false
  end

  for _, event in pairs(events) do
    	ChatFrame_AddMessageEventFilter(event, ChatFilter)
  end
end
